Thêm thông tin tại cửa hàng vào các sản phẩm tại cửa hàng địa phương

Để mang đến trải nghiệm mua sắm liền mạch, hợp nhất và tích hợp, khi bạn thêm một sản phẩm bằng Merchant API, sản phẩm đó sẽ có sẵn theo mặc định cho tất cả các vị trí xuất hiện đã bật, bao gồm cả loại vị trí xuất hiện trực tuyến và tại địa phương. Đây là một phần của chiến lược đa kênh trong mua sắm.

Để chỉ định thông tin bổ sung về tình trạng còn hàng tại địa phương của sản phẩm, bạn sử dụng API phụ Kho hàng để cho biết sản phẩm có sẵn tại cửa hàng thực tế.

Nếu bạn đang di chuyển từ Content API for Shopping, hãy xem phần Di chuyển tính năng quản lý khoảng không quảng cáo.

Sau đây là các bước cần thiết để thêm thông tin tại cửa hàng cho sản phẩm tại địa phương:

Kết nối doanh nghiệp của bạn với Merchant Center

Đăng ký trang thông tin miễn phí tại địa phương

Sau khi liên kết Trang doanh nghiệp với tài khoản Merchant Center, bạn có thể đăng ký trang thông tin miễn phí tại địa phương. Đảm bảo bạn tuân thủ các chính sách về trang thông tin miễn phí.

Khi bạn tham gia chương trình trang thông tin miễn phí tại địa phương, các sản phẩm tại cửa hàng của bạn có thể xuất hiện trong trang thông tin miễn phí trên các sản phẩm của Google.

Xác minh rằng bạn có sản phẩm tại cửa hàng địa phương

Trước khi chèn kho hàng tại địa phương vào sản phẩm, bạn nên kiểm tra để đảm bảo rằng sản phẩm của bạn nhắm đến đích đến tại địa phương (hoặc tại cửa hàng), còn được gọi là phương thức tiếp thị. Ví dụ: quảng cáo kho hàng tại địa phươngtrang thông tin miễn phí tại địa phương là các phương thức tiếp thị tại địa phương. Để biết thêm thông tin về đích đến, hãy xem bài viết Phương thức tiếp thị.

Bạn xác định vị trí xuất hiện tại địa phương cho sản phẩm ở cấp nguồn dữ liệu thông qua Destinations hoặc ở cấp product thông qua ProductAttributes, chẳng hạn như includedDestinations.

Chèn thông tin tại cửa hàng

Sau khi thêm sản phẩm tại địa phương vào tài khoản Merchant Center, bạn phải chỉ định thông tin tại cửa hàng cho các sản phẩm đó, chẳng hạn như storeCode hoặc availability, và thông tin không bắt buộc như price. Để biết thêm thông tin về các trường mà bạn có thể cung cấp, hãy xem Quy cách dữ liệu kho hàng tại địa phương.

Trong ví dụ sau, bạn sẽ thêm thông tin tại cửa hàng cho một sản phẩm bằng cách sử dụng phương thức localInventories.insert:

POST https://merchantapi.googleapis.com/inventories/v1/accounts/{ACCOUNT_ID}/products/{en~US~SKU12345}/localInventories:insert
{
  "storeCode": "123456",
  "localInventoryAttributes": {
    "price": {
      "amountMicros": "33450000",
      "currencyCode": "USD"
    },
    "availability": "OUT_OF_STOCK"
  }
}

Các mã mẫu sau đây cho biết cách thêm thông tin tại cửa hàng cho một sản phẩm:

Java

import com.google.api.gax.core.FixedCredentialsProvider;
import com.google.auth.oauth2.GoogleCredentials;
import com.google.shopping.merchant.inventories.v1.InsertLocalInventoryRequest;
import com.google.shopping.merchant.inventories.v1.LocalInventory;
import com.google.shopping.merchant.inventories.v1.LocalInventoryAttributes;
import com.google.shopping.merchant.inventories.v1.LocalInventoryAttributes.Availability;
import com.google.shopping.merchant.inventories.v1.LocalInventoryServiceClient;
import com.google.shopping.merchant.inventories.v1.LocalInventoryServiceSettings;
import com.google.shopping.type.Price;
import shopping.merchant.samples.utils.Authenticator;
import shopping.merchant.samples.utils.Config;

/** This class demonstrates how to insert a Local inventory for a given product */
public class InsertLocalInventorySample {

  private static String getParent(String accountId, String productId) {
    return String.format("accounts/%s/products/%s", accountId, productId);
  }

  public static void insertLocalInventory(Config config, String productId, String storeCode)
      throws Exception {
    GoogleCredentials credential = new Authenticator().authenticate();

    LocalInventoryServiceSettings localInventoryServiceSettings =
        LocalInventoryServiceSettings.newBuilder()
            .setCredentialsProvider(FixedCredentialsProvider.create(credential))
            .build();

    String parent = getParent(config.getAccountId().toString(), productId);

    try (LocalInventoryServiceClient localInventoryServiceClient =
        LocalInventoryServiceClient.create(localInventoryServiceSettings)) {

      Price price = Price.newBuilder().setAmountMicros(33_450_000).setCurrencyCode("USD").build();

      InsertLocalInventoryRequest request =
          InsertLocalInventoryRequest.newBuilder()
              .setParent(parent)
              .setLocalInventory(
                  LocalInventory.newBuilder()
                      .setStoreCode(storeCode)
                      .setLocalInventoryAttributes(
                          LocalInventoryAttributes.newBuilder()
                              .setAvailability(Availability.OUT_OF_STOCK)
                              .setPrice(price)
                              .build())
                      .build())
              .build();

      System.out.println("Sending insert LocalInventory request");
      LocalInventory response = localInventoryServiceClient.insertLocalInventory(request);
      System.out.println("Inserted LocalInventory Name below");
      System.out.println(response.getName());
    } catch (Exception e) {
      System.out.println(e);
    }
  }

  public static void main(String[] args) throws Exception {
    Config config = Config.load();
    // An ID assigned to a product by Google. In the format
    // contentLanguage~feedLabel~offerId
    String productId = "en~label~1111111111";
    // The code uniquely identifying each store.
    String storeCode = "Example1";
    insertLocalInventory(config, productId, storeCode);
  }
}

PHP

use Google\ApiCore\ApiException;
use Google\Shopping\Merchant\Inventories\V1\LocalInventory;
use Google\Shopping\Merchant\Inventories\V1\Client\LocalInventoryServiceClient;
use Google\Shopping\Merchant\Inventories\V1\InsertLocalInventoryRequest;
use Google\Shopping\Merchant\Inventories\V1\LocalInventoryAttributes;
use Google\Shopping\Merchant\Inventories\V1\LocalInventoryAttributes\Availability;
use Google\Shopping\Type\Price;

/**
 * Class to insert a `LocalInventory` to a given product in your
 * merchant account.
 *
 * Replaces the full `LocalInventory` resource if an entry with the same
 * [`storeCode`]
 * [google.shopping.merchant.inventories.v1beta.LocalInventory.storeCode]
 * already exists for the product.
 *
 * It might take up to 30 minutes for the new or updated `LocalInventory`
 * resource to appear in products.
 */

class InsertLocalInventory
{
    // ENSURE you fill in the merchant account and product ID for the sample to
    // work.
    private const PARENT = 'accounts/[INSERT_ACCOUNT_HERE]/products/[INSERT_PRODUCT_HERE]';
    // ENSURE you fill in store code for the sample to work.
    private const LOCAL_INVENTORY_STORE_CODE = 'INSERT_STORE_CODE_HERE';

    /**
     * Inserts a local inventory underneath the parent product.
     *
     * @param string $parent The account and product where this inventory will be inserted.
     *     Format: `accounts/{account}/products/{product}`
     * @param string $localInventoryRegion
     *     ID of the region for this
     *     `LocalInventory` resource. See the [Local availability and
     *     pricing](https://support.google.com/merchants/answer/9698880) for more details.
     */
    public function insertLocalInventorySample(
        string $parent,
        string $localInventoryStoreCode
    ): void {
        // Gets the OAuth credentials to make the request.
        $credentials = Authentication::useServiceAccountOrTokenFile();

        // Creates options config containing credentials for the client to use.
        $options = ['credentials' => $credentials];

        // Creates a client.
        $localInventoryServiceClient = new LocalInventoryServiceClient($options);

        // Creates a price object.
        $price = new Price(
            [
                'currency_code' => "USD",
                'amount_micros' => 33450000,
            ]
        );

        // Creates a new local inventory object.
        $localInventory = (new LocalInventory())
            ->setStoreCode($localInventoryStoreCode)
            ->setLocalInventoryAttributes((new LocalInventoryAttributes())
                ->setAvailability(Availability::IN_STOCK)
                ->setPrice($price));

        $request = (new InsertLocalInventoryRequest())
            ->setParent($parent)
            ->setLocalInventory($localInventory);

        // Calls the API and catches and prints any network failures/errors.
        try {
            /** @var LocalInventory $response */
            $response = $localInventoryServiceClient->insertLocalInventory($request);
            printf('Response data: %s%s', $response->serializeToJsonString(), PHP_EOL);
        } catch (ApiException $ex) {
            printf('Call failed with message: %s%s', $ex->getMessage(), PHP_EOL);
        }
    }

    /**
     * Helper to execute the sample.
     */
    public function callSample(): void
    {
        // Makes the call to insert the local inventory to the parent product
        // for the given region.
        $this->insertLocalInventorySample($this::PARENT, $this::LOCAL_INVENTORY_STORE_CODE);
    }

}


$sample = new InsertLocalInventory();
$sample->callSample();

Python

from examples.authentication import configuration
from examples.authentication import generate_user_credentials
from google.shopping import merchant_inventories_v1
from google.shopping.merchant_inventories_v1.types import LocalInventoryAttributes


# ENSURE you fill in product ID and store code for the sample to
# work.
_ACCOUNT = configuration.Configuration().read_merchant_info()
# ENSURE you fill in product ID for the sample to work.
_PRODUCT = "INSERT_PRODUCT_HERE"
_PARENT = f"accounts/{_ACCOUNT}/products/{_PRODUCT}"
# ENSURE you fill in store code for the sample to work.
_STORE_CODE = "INSERT_STORE_CODE_HERE"


def insert_local_inventory():
  """Inserts a `LocalInventory` to a given product.

  Replaces the full `LocalInventory` resource if an entry with the same
  `region` already exists for the product.

  It might take up to 30 minutes for the new or updated `LocalInventory`
  resource to appear in products.
  """

  # Gets OAuth Credentials.
  credentials = generate_user_credentials.main()

  # Creates a client.
  client = merchant_inventories_v1.LocalInventoryServiceClient(
      credentials=credentials
  )

  # Creates a Local inventory and populate its attributes.
  local_inventory = merchant_inventories_v1.LocalInventory()
  local_inventory.store_code = _STORE_CODE
  local_inventory.local_inventory_attributes.availability = (
      LocalInventoryAttributes.Availability.IN_STOCK
  )
  local_inventory.local_inventory_attributes.price = {
      "currency_code": "USD",
      "amount_micros": 33450000,
  }

  # Creates the request.
  request = merchant_inventories_v1.InsertLocalInventoryRequest(
      parent=_PARENT,
      local_inventory=local_inventory,
  )

  # Makes the request and catch and print any error messages.
  try:
    response = client.insert_local_inventory(request=request)

    print("Insert successful")
    print(response)
  except RuntimeError as e:
    print("Insert failed")
    print(e)


if __name__ == "__main__":
  insert_local_inventory()

cURL

  curl --location
  'https://merchantapi.googleapis.com/inventories/v1/accounts/{ACCOUNT_ID}/products/{en~US~SKU12345}/localInventories:insert' \
  --header 'Content-Type: application/json' \
  --header 'Authorization: Bearer {API_TOKEN}' \
  --data '{
     "storeCode": "123456",
     "localInventoryAttributes": {
       "price": {
         "amountMicros": "33450000",
         "currencyCode": "USD"
       },
       "availability": "OUT_OF_STOCK"
     }
  }'

Một lệnh gọi thành công sẽ trả về tài nguyên LocalInventory mới tạo cùng với các giá trị mà bạn đã cung cấp, nhưng có thể tài nguyên này không thể hiện đầy đủ dữ liệu kho hàng cuối cùng. Có thể mất đến 30 phút thì LocalInventory mới xuất hiện trong sản phẩm.